;*********************************************************************
; Mdulo: IERL
; Uso:    IAAA Experimenal Representation Language
; Autor:  Pedro R. Muro
;         Roberto Sobreviela Ruiz
; email:  419245@cepsz.unizar.es
;         sobreviela@teleline.es
;*********************************************************************
; Fichero: BDC.lsp      Fecha Creacin: 8 de julio de 1999
; Versin: 0.0.1        Fecha Modificacin: 12 de julio de 1999
; Estado:  Desarrollo   Autor: Roberto Sobreviela Ruiz
;---------------------------------------------------------------------
; Uso: Base de conocimiento para la prueba de IERL.
; Comentarios:
; Historia:
;*********************************************************************

(defun base-form (name)
   (form :name name
         :is-a nil)
   (create-method name 'set-value   #'method-set-value)
   (create-method name 'set-aspect  #'method-set-aspect)
   (create-method name 'set-minimun #'method-set-minimun)
   (create-method name 'set-maximun #'method-set-maximun)
   (create-method name 'set-type    #'method-set-type)
   (create-method name 'set-have    #'method-set-have)
   (create-method name 'get-value   #'method-get-value)
   (create-method name 'get-aspect  #'method-get-aspect)
   (create-method name 'get-minimun #'method-get-minimun)
   (create-method name 'get-maximun #'method-get-maximun)
   (create-method name 'get-type    #'method-get-type)
   (create-method name 'get-have    #'method-get-have))

(defun animales ()
   (let ()
      (base-form 'objeto)
      (form :name 'vertebrado :is-a 'objeto)
      (form :name 'mamifero   :is-a 'vertebrado)
      (form :name 'persona    :is-a 'mamifero)
      (form :name 'hombre     :is-a 'persona)
      (form :name 'mujer      :is-a 'persona)
      (form :name 'paco       :is-a 'hombre)
      
      (form :name 'espina    :is-a 'objeto)
      (form :name 'digito    :is-a 'objeto)
      (form :name 'dedo-mano :is-a 'digito)
      (form :name 'dedo-pie  :is-a 'digito)
      (form :name 'pie       :is-a 'objeto)
      (form :name 'mano      :is-a 'objeto)
      
      (set-have 'vertebrado (list '(espina 1)))
      (set-have 'persona    (list '(pie 2) '(mano 2)))
      (set-have 'pie        (list '(dedo-pie 5)))
      (set-have 'mano       (list '(dedo-mano 5)))))
 

(animales)

;;; 2. Comprobar el acceso a las partes de una form
;;;

(what-does-it-have-at-this-level? 'paco)
(what-does-it-have-at-this-level? 'persona)

;;; 3. Comprobar la herencia de partes por herencia normal
;;;

(what-does-it-have? 'mamifero)
(what-does-it-have? 'paco)

;;; 4. Comprobar los ascendientes de una form
;;;

(what-is-this-form? 'paco)
(what-is-this-form? 'dedo-pie)

;;; 5. Comprobar todos los ascendientes de una form
;;;

(what-is-it? 'paco)
(what-is-it? 'dedo-mano)

;;; 6. Preguntar si una form tiene un ascendiente
;;;

(is-a? 'paco 'vertebrado)
(is-a? 'paco 'pie)

;;; 7. Comprobar cuantos elementos de una parte tiene una form
;;;

(how-many-does-this-form-have-at-this-level? 'paco 'pie)
(how-many-does-this-form-have-at-this-level? 'vertebrado 'espina)
(how-many-does-this-form-have-at-this-level? 'pie 'dedo-pie)
(how-many-does-this-form-have-at-this-level? 'pie 'digito)

;;; 8. Comprobar la herencia del nmero de elementos de las partes
;;;    mediante la herencia mltiple y la herencia ortogonal.

(how-many-does-it-have? 'paco 'espina)
(how-many-does-it-have? 'paco 'pie)
(how-many-does-it-have? 'paco 'dedo-pie)
(how-many-does-it-have? 'paco 'digito)
