;*********************************************************************
; Mdulo: NIMA
; Uso:    Modelo de datos del NIMA
; Autor:  Mara Navas Tapiador
; email:  mnavas@ebro.cps.unizar.es
;*********************************************************************
; Fichero: nima.lsp      Fecha Creacin: 18 de junio de 2002
; Versin: 0.0.1        Fecha Modificacin: 29 de junio de 2002
; Estado:  Desarrollo   Autor: Mara Navas Tapiador
;---------------------------------------------------------------------
; Uso: Base de conocimiento para los elemntos geogrficos de la base 
; de datos del NIMA.
; Comentarios: Realizado para el curso de doctorado de Introduccin
;  		al procesamiento del lenguaje natural.
; Historia:
;*********************************************************************   
   
(defun nima ()
   (let ()
      (base-form 'objeto)
      (form :name 'feature :is-a 'type-feature :slots (list '(featureDesignation) '(country) '(nameType) '(latitud) '(longitud)))
      (form :name 'pais :is-a 'objeto :slots (list '(siglas)))
      (form :name 'type-feature :is-a 'objeto :slots (list '(fc)))
      (form :name 'distance :is-a 'objeto :slots (list '(degrees)))
      (form :name 'distance-max :is-a 'distance)
    
      
      
      (form :name 'Administrative :is-a 'type-feature)
      (set-value 'Administrative 'fc 'A)

      (form :name 'Hydrographic :is-a 'type-feature)
      (set-value 'Hydrographic 'fc 'H)

      (form :name 'Area :is-a 'type-feature)
      (set-value 'Area  'fc 'L)

      (form :name 'Place :is-a 'type-feature)
      (set-value 'Place 'fc 'P)

      (form :name 'Road :is-a 'type-feature)
      (set-value 'Road 'fc 'R)

      (form :name 'Spot :is-a 'type-feature)
      (set-value 'Spot  'fc 'S)

      (form :name 'Hypsographic :is-a 'type-feature)
      (set-value 'Hypsographic  'fc 'T)

      (form :name 'Udrsea :is-a 'type-feature)
      (set-value 'Udrsea  'fc 'U)

      (form :name 'Vegetation :is-a 'type-feature)
      (set-value 'Vegetation  'fc 'V)


      (form :name 'Andorra :is-a 'pais)
      (set-value 'Andorra 'siglas 'AN)

      (form :name 'France :is-a 'pais)
      (set-value 'France 'siglas 'FR)

      (form :name 'Gibraltar :is-a 'pais)
      (set-value 'Gibraltar 'siglas 'GI)

      (form :name 'Morocco :is-a 'pais)
      (set-value 'Morocco 'siglas 'MO)

      (form :name 'Portugal :is-a 'pais)
      (set-value 'Portugal 'siglas 'PO)

      (form :name 'Spain :is-a 'pais)
      (set-value 'Spain 'siglas 'SP)
    
      (form :name 'Vatican :is-a 'pais)
      (set-value 'Vatican 'siglas 'VT)
      
       )
)
 