;;; -*- Mode:Lisp; Package:DYPAR; Base:10; -*-

;;;        LastEditDate = Fri Aug 24 12:44:40 1984  - Excalibur

;;; ----------------------------------------------------------------
;;;
;;;       (c) Copyright, 1982,
;;;          by Mark Boggs
;;;          All rights reserved
;;;
;;; ----------------------------------------------------------------

;;; Semvar.l created by WMB on or about Thu Apr  9 15:51:56 1981
;;; This file contains most of the global variable assignments that are
;;; used by more than one part of the parser.  They have been placed
;;; here for ease of modification.  They are loaded before the grammar.

;;; HISTORY
; 17-Jan-89  Mark Boggs (boggs) at Rank Xerox, Spain
;	Added package support.
;	Made file dependencies explicit.
;

(in-package "DYPAR"); :use '("LISP" "USER"))

(eval-when (compile)
  (if (not (boundp '*macros-loaded*)) (load 'macros)))

;;; The next few lines contain initializations for global variables, which
;;; might be used in more than one file.  Since var.lsp is loaded first, these
;;; initializations are overridden by those in the files that use these
;;; variables.  They are just here for SAFETY'S sake.

(dv !!nodes nil)
(dv !!props nil)

;;; dps is a routine that sets up some property list values.
;;; These invocations of DPS are for the semantic network.
;(dps property relation synonym)
;(dps concept-type noinherit: t)
;(dps plural inverse singular noinherit: t)
;(dps singular noinherit: t)
;(dps inverse noinherit: t)

;;; From newxpar Turns on the match tracer.  This is the default setting,
;;; but can be overridden if no information is desired about the progress of
;;; match.
(dv !ptrace t)
(dv !interactive t)

;;; Lists of rules and transformations are stored respectively in:

(dv !!patrules nil)
(dv !!patvars nil)
(dv !!pattrans nil)
(dv !!patqueries nil)
(dv !!nonterms nil)

(dv !!vowels (a e i o u))

(dv !months (January February March April May June July August
       September October November December))

;;; !watch is from the cross-referencing stuff.
(dv !watch nil)
(defvar !!bpunct '(%lf %cr %period %emark))

(defvar *vars-loaded* t)